<template>
  <div
    v-show="message !== 'O evento começou'"
    class="background-secondary text-white flex items-center"
  >
    <div
      class="container mx-auto flex flex-row items-center text-center md:text-left h-full"
    >
      <div
        class="inline-flex flex-col justify-center items-center w-full h-full"
      >
        <div class="flex-grow"></div>
        <h1 style="padding-top: 84px;" class="text-2xl">Final em breve!</h1>
        <div class="flex-grow"></div>
        <div class="svg-container">
          <svg viewBox="0 0 1 1" stroke="red" stroke-width="0" v-on:click="easterEgg()">
            <!-- outter -->
            <g :class="`${isEaster? 'easter' : 'not-easter'}`">
              <circle
                v-for="(angle, index) in petals"
                v-bind:key="index"
                fill="red"
                stroke-width="0"
                r="0.015"
                cx="0.5"
                cy="0.5"
                href="#petal"
                :transform="`rotate(${angle} 0.5 0.5) translate(0.4 0)`"
              />
            </g>
            <path
              :d="`
                M 0.5 0.1
                A
                  0.4,0.4
                  0,${+(outterPercentage > 0.5)},1
                  ${0.5 + 0.4 * Math.cos((1 - outterPercentage) * 2 * Math.PI - 3 * Math.PI / 2)}
                  ${0.5 - 0.4 * Math.sin((1 - outterPercentage) * 2 * Math.PI - 3 * Math.PI / 2)}
              `"
              fill="none"
              stroke="red"
              stroke-width="0.032"
              stroke-linecap="round"
              :class="`${isEaster? 'easter-reverse' : 'not-easter'}`"
            />
            <!-- inner -->
            <g :class="`${isEaster? 'easter-reverse' : 'not-easter'}`">
              <circle
                v-for="(angle, index) in petals"
                v-bind:key="index + 100"
                fill="#ff7f00"
                stroke-width="0"
                r="0.015"
                cx="0.5"
                cy="0.5"
                href="#petal"
                :transform="`rotate(${angle} 0.5 0.5) translate(0.35 0)`"
              />
            </g>
            <path
              :d="`
                M 0.5 0.15
                A
                  0.35,0.35
                  0,${+(innerPercentage > 0.5)},1
                  ${0.5 - 0.35 * Math.cos(innerPercentage * 2 * Math.PI - 3 * Math.PI / 2)}
                  ${0.5 - 0.35 * Math.sin(innerPercentage * 2 * Math.PI - 3 * Math.PI / 2)}
              `"
              fill="none"
              stroke="#ff7f00"
              stroke-width="0.032"
              stroke-linecap="round"
              :class="`${isEaster? 'easter' : 'not-easter'}`"
            />
          </svg>
          <p>
            <span style="color: red; font-size: 60px">{{days}}</span><br>
            <span style="color: red;transform: translate(0, -60%); display:inline-block">dias</span><br>
            <span style="color: #ff7f00; font-size: 20px;">
              {{hours.toString().padStart(2, "0")}}h {{minutes.toString().padStart(2, "0")}}m {{seconds.toString().padStart(2, "0")}}s
            </span><br>
          </p>
        </div>
        <div class="flex-grow"></div>
        <a
          id="scroll"
          v-smooth-scroll="{ duration: 750, offset: 0 }"
          href="#subscribe"
          aria-label="Scroll para o início da página"
        >
          <span id="scroll-icon">
            <i class="fas fa-chevron-down"></i>
          </span>
        </a>
        <div class="flex-grow"></div>
      </div>
    </div>
  </div>
</template>

<script>

export default {
  data: function() {
    return {
      start: "",
      end: "",
      interval: "",
      days: "77",
      minutes: "6",
      hours: "4",
      seconds: "10",
      message: "",
      innerPercentage: 0.1,
      outterPercentage: 0.1,
      isEaster: false,
    petals: [],
    };
  },
  mounted() {
    const interhackDate = new Date("11/09/2019 10:00:00");
    const petalsAmmount = 24;
    for(let i = 0; i < petalsAmmount; i ++)
      this.petals.push(i * 360 / petalsAmmount);
    setInterval(() => {
      const diffMilisseconds = interhackDate.getTime() - Date.now();
      const timeRemaining = this.parseMilisseconds(diffMilisseconds);
      this.days = timeRemaining.days;
      this.hours = timeRemaining.hours;
      this.minutes = timeRemaining.minutes;
      this.seconds = timeRemaining.seconds;
      this.outterPercentage = diffMilisseconds / 8701658403;
      this.innerPercentage = (diffMilisseconds % 8.64e+7) / 8.64e+7;
    });
  },
  methods: {
    parseMilisseconds(ms){
      const days = Math.floor(ms / 8.64e+7);
      const hours = Math.floor((ms % 8.64e+7) / 3.6e+6);
      const minutes = Math.floor((ms % 8.64e+7 % 3.6e+6) / 60000);
      const seconds = Math.floor((ms % 8.64e+7 % 3.6e+6 % 60000) / 1000);
      return {days, hours, minutes, seconds};
    },

    async easterEgg(){
      if(this.isEaster) return;
      const sleep = time => new Promise(resolve => setTimeout(resolve, time));
      this.isEaster = true;
      await sleep(3000);
      this.isEaster = false;
    }
  }
};
</script>

<style scoped>
svg {
  width: 300px;
  height: 300px;
  position: relative;
}

@keyframes easter-egg {
  from{transform: rotate(0deg);}
  to{transform: rotate(360deg);}
}

@keyframes easter-egg-reverse {
  from{transform: rotate(360deg);}
  to{transform: rotate(0deg);}
}

.easter{
  transform-origin: 0.5px 0.5px;
  animation-name: easter-egg;
  animation-duration: 3s;
  animation-timing-function: ease;
  animation-direction: normal;
}

.easter-reverse{
  transform-origin: 0.5px 0.5px;
  animation-name: easter-egg-reverse;
  animation-duration: 3s;
  animation-timing-function: ease;
  animation-direction: normal;
}

.svg-container{
  width: 300px;
  height: 300px;
  display: grid;
  grid-template-rows: 0 100%;
  text-align: center;
}

.svg-container p{
  font-family: 'Trebuchet MS', 'Lucida Sans Unicode', 'Lucida Grande', 'Lucida Sans', Arial, sans-serif;
  width: max-content;
  height: max-content;
  justify-self: center;
  align-self: center;
  user-select: none;
}

.background-secondary {
  background-color: config("colors.secondary");
  height: calc(var(--vh, 1vh) * 100);
  position: relative;
}

.text-large {
  font-size: 32px;
}

#scroll {
  background-color: white;
  border-radius: 100%;
  height: 50px;
  width: 50px;
  box-shadow: 0px 2px 5px rgba(0, 0, 0, 0.25);
  display: flex;
  align-items: center;
  justify-content: center;
}

#scroll:hover {
  animation-name: animationHover;
  animation-duration: 2s;
  animation-iteration-count: 1;
  animation-fill-mode: backwards;
}

@keyframes animationHover {
  0% {
    transform: translateY(0);
  }
  20% {
    transform: translateY(10px);
  }
  40% {
    transform: translateY(0);
  }
}

#scroll-icon {
  color: config("colors.secondary");
  font-size: 24px;
  height: 24px;
}

@media (min-width: 992px) {
  .text-large {
    font-size: 48px;
  }
}
</style>
